#
# spec file for package Catch2-2
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define srcname Catch2
Name:           Catch2-2
Version:        2.13.10
Release:        1.2
Summary:        A modern, C++-native, header-only, test framework for unit-tests, TDD and BDD
License:        BSL-1.0
URL:            https://github.com/catchorg/Catch2/
Source:         https://github.com/catchorg/%{srcname}/archive/v%{version}.tar.gz#/%{srcname}-%{version}.tar.gz
#PATCH-FIX-OPENSUSE fix-pragmas-old-gcc.patch -- Fix usage of gcc pragmas for old gcc version on Leap gh#catchorg/Catch2#2416
Patch0:         fix-pragmas-old-gcc.patch
BuildRequires:  cmake >= 3.5
BuildRequires:  gcc-c++ >= 6
BuildRequires:  pkgconfig

%description
Catch2 stands for C++ Automated Test Cases in a Header and is a multi-paradigm
test framework for C++. which also supports Objective-C (and maybe C).
It is primarily distributed as a single header file, although certain
extensions may require additional headers.

This package provides version 2.x of Catch2.

%package devel
Summary:        A modern, C++-native, header-only, test framework for unit-tests, TDD and BDD
Conflicts:      Catch2-devel >= 3
Provides:       Catch2-devel = %{version}

%description devel
Catch2 stands for C++ Automated Test Cases in a Header and is a multi-paradigm
test framework for C++. which also supports Objective-C (and maybe C).
It is primarily distributed as a single header file, although certain
extensions may require additional headers.

This package provides version 2.x of Catch2.

%prep
%autosetup -p1 -n %{srcname}-%{version}

%build
%cmake \
       -DCMAKE_INSTALL_DOCDIR:PATH=%{_defaultdocdir}/%{name} \
       -DPKGCONFIG_INSTALL_DIR:PATH=%{_libdir}/pkgconfig \
       -DCATCH_BUILD_EXAMPLES:BOOL=ON
%cmake_build

%install
%cmake_install

%check
%ctest

%files devel
%license LICENSE.txt
%doc README.md CODE_OF_CONDUCT.md
%doc %{_defaultdocdir}/%{name}
%{_datadir}/%{srcname}/
%{_includedir}/catch2/
%{_libdir}/cmake/%{srcname}/
%{_libdir}/pkgconfig/catch2.pc

%changelog
* Wed Jan 18 2023 Atri Bhattacharya <badshah400@gmail.com>
- Update to version 2.13.10:
  * Fixed issue with catch_discover_tests when there is multiple of
    256 tests (gh#catchorg/Catch2#2401, gh#catchorg/Catch2#2503).
  * Catch2-provided main and wmain are explicitly marked as __cdecl
    when compiled with MSVC (gh#catchorg/Catch2#2486,
    gh#catchorg/Catch2#2487).
  * Replaced deprecated std::aligned_storage
    (gh#catchorg/Catch2#2419, gh#catchorg/Catch2#2420).
- Minor rebase of fix-pragmas-old-gcc.patch to apply cleanly.
* Sat Oct  8 2022 Atri Bhattacharya <badshah400@gmail.com>
- Initial package:
  * Branch off from obs://devel:libraries:c_c++/Catch2 at version
    2.13.9 and rename src package to Catch2-2.
  * Catch2-2-devel: Add 'Provides: Catch2-devel = %%{version}'
    and 'Conflicts: Catch2-devel >= 3'.
  * Drop CMAKE_RELEASE_TYPE=Release to use default
  'RelWithDebInfo' value from %%cmake macro.
